#!/usr/local/perl
#Alexei Fedorov, January 2015.  (PopulationDistribution_vrGV-ids_pop.pl programs)
#this program prduce statistical assessment and frendly presentation of vrGV table for one individual (e.g. PopultionsDistribution_vrGVs_HG00255 file)
#v3 takes coordinates of GVs and calculates the physical size of IBD regions
#v4 presents the results according to the request of Gursel Serpen 01/16/2016
#v4.2 has fixed the problem with the chromosome shift within scaning window new variables $CHR_begin $CHR_end1 $CHR_end2 
$c=0; @b=@a=(); %bufer =(); $c1=0; @match =(); %start_line = %start_position = %end_line =%end_position = ();
$id_pop = substr($ARGV[0],0,3);
$id_ind =substr($ARGV[0],4);
print "POP IS $id_pop \t individual is $id_ind \n";
open(OUT5, ">>APRIL2015/All_Pairs.txt") || die;
open(OUT2, ">APRIL2015/$ARGV[0]_dat3") || die;
open(IN, "$ARGV[0]") || die "Can't open $ARGV[0] : $!\n";
while(<IN>) {
	chomp($_);
	@b=split(/\s+/, $_);
	for $x (0..$#b) { 
		if ($b[$x] eq $ARGV[0]) {$r = $x; last;} 
	}  
	splice(@b,$r,1); #these  lines have removed the analysed individual from the table 
	$line ='';
	for $x (0..$#b) { $line .= $b[$x] ."\t";} 
	push(@a, $line); #array @a represents lines from the input table with removed individual under analysis
	for $x (0..$#b) {
		$e[$c][$x] = $b[$x]; #this @e 2D array contains represent all elements in the input table with removed individual under analysis
	}
	$c++; #number of lines in the input table
}

$SW =8; # size of the Scanning Window measuring number of vrGVs under analysis. NOTE $SW is an integer counting from 0, which means $SW =8 corresponds to nine rows
%seen =();
for $x (0..$c) {
	$c1++;
	for $w (0..$SW)  {
		if($e[$x+$w][5]) {$bufer{$e[$x+$w][5]}++; }
		if($e[$x+$w][6]) {$bufer{$e[$x+$w][6]}++; }
		if($e[$x+$w][7]) {$bufer{$e[$x+$w][7]}++; }
	}
	@match=();$size =0; $CHR_begin = $CHR_end1 = $CHR_end2 = '';
	foreach $k (keys %bufer) {	
		if ($bufer{$k}>=5 ) {
			push (@match, $k);
		}
	}
	if ($#match >=0) {
		for $m (0..$#match) {
			$str =0; #stretching the scanning window
			$count =0; #counting number of shared vrGVs on the same chromosome
			for $z (0..$SW) {if ($a[$x+$z] =~/$match[$m]/) {$start_line{$match[$m]}=$z+$x; $start_position{$match[$m]}=$e[$x+$z][1]; $CHR_begin=$e[$x+$z][0]; last;}}
			for $z (0..$SW) {if ($a[$x+$z] =~/$match[$m]/) {$end_line{$match[$m]}=$z; $end_position{$match[$m]}=$e[$x+$z][1]; if($e[$x+$z][0] ne $CHR_begin) {last;} else {$count++;} }}
			if ($count < 5) {next;}
			LABLE: {
				$flag = 0;
				if ($a[$x+$SW+$str+1] =~/$match[$m]/) {
					if($e[$x+$SW+$str+1][0] ne $CHR_begin) {}
					else {$bufer{$match[$m]}++;$flag=1; $end_line{$match[$m]}=$x+$SW+$str+1; $end_position{$match[$m]}=$e[$x+$SW+$str+1][1];} 
				}
				if ($a[$x+$SW+$str+2] =~/$match[$m]/) {
					 if($e[$x+$SW+$str+2][0] ne $CHR_begin) {}
					else {$bufer{$match[$m]}++;$flag=1; $end_line{$match[$m]}=$x+$SW+$str+2; $end_position{$match[$m]}=$e[$x+$SW+$str+2][1];} 
				}  
				if ($flag) {$str+=2; redo LABLE;}
			}
			if ($seen{$match[$m]} < $x) { 
				$size = $end_position{$match[$m]} - $start_position{$match[$m]}; $shift ='';
				if ($size < -1000) {print "cromosome shift for $x \t$size\n"; $shift ="CHRshift"; $size=10000;}
			#	print OUT "\t\t\t$match[$m]\t$bufer{$match[$m]}\tstart $start_position{$match[$m]}\tend $end_position{$match[$m]}\t$size\t";
					$id_pop2 = substr($match[$m],0,3);
					$id_ind2 =substr($match[$m],4);

				print OUT2 "\n$e[$x][0]\t$e[$x][1]\t$e[$x][2]\t$e[$x][3]\t$e[$x][4]\t$id_pop","_", "$id_ind\t$id_pop2","_", "$id_ind2\t1\t$size\t$bufer{$match[$m]}\t$shift";	
			}
			$seen{$match[$m]} =$str+$x+$SW;
		}
	}
	%bufer =();
}
close (OUT2);
%seen =(); $line_c =0;
open(OUT4, ">APRIL2015/$ARGV[0]_dat4") ||die;
open(IN2, "APRIL2015/$ARGV[0]_dat3");
while (<IN2>) {
	chomp $_; $line_c++;
	chop $_;
	@line = split(/\s+/, $_);
	if ($#line !=9) {print "counting problem $#line \t $line_c \n";}
	unless ($seen{$line[6]}) {
		if ($#line==9) {@{$seen{$line[6]}} = @line;}
		else {print "problem with $line_c line $_\n";}
	}
	else {
		${$seen{$line[6]}}[7]++;
		${$seen{$line[6]}}[8] +=$line[8];
		${$seen{$line[6]}}[9] +=$line[9];
	}
}
 foreach $k (keys %seen) {
	print OUT4 "${$seen{$k}}[5]\t${$seen{$k}}[6]\t${$seen{$k}}[7]\t${$seen{$k}}[8]\t${$seen{$k}}[9]\n";
	print OUT5 "${$seen{$k}}[5]\t${$seen{$k}}[6]\t${$seen{$k}}[7]\t${$seen{$k}}[8]\t${$seen{$k}}[9]\n";
}
