#!/usr/local/perl
#program was created on 12/17/2014 to investigate the distribution of vrGVs accorss 14 populations
$c=$LINE=0; @b =(); %column_id=(); %column_pop =();
open(OUT, ">vrGVdatabase.txt");
open(IN, "1000genomes_ID"); #supplementary input file that contains IDs of all 1092 individuals (provided on Fedorov lab web page)
while(<IN>) {
	chomp($_);
	@b=split(/\t/, $_); 
}
print "$b[$#b] $#b \n";
for $x (0..$#b) {
	$column_id{$x} = $b[$x];
}
open(IN2, "20111108_1000genomes_samples2.txt") || die "Can't open 20111108 : $!\n"; #supplementary input file that contains IDs and Population-IDs of all 1092 individuals (provided on Fedorov lab web page)
while(<IN2>) {
	$LINE++;
	if ($_ =~/^\s*([A-Z]{3})/){ $pop = $1;} 
	else {print "PROBLEM with Population name line $LINE \n"; }
	@a=split(/\t/, $_); 
	for $x (0..$#b) {
        	if ($b[$x] eq $a[2]) {$column_pop{$x} = $pop; $c++; next;}
	}	
}
print "TWO hashes have been created number of individuals is $c \n";


for $L (1..22) {
	$name = '/home/asahama/ALL.chr'.$L.'.phase1_release_v3.20101123.snps_indels_svs.genotypes.vcf.gz'; #location of the 1000 Genome database on the Fedorov's BPG Linux workstation
	#$name = '/home/afedorov/rareSNP_chr'.$L.'.gz';
	open (FILE, "zcat $name |") || die "could not open file \n";
	$line_N =0;
	while (<FILE>){
		$line_N++;  
        	if ($line_N > 30) {
			$count = () = $_ =~ /\|1/g;
			$count2 = () = $_ =~ /1\|/g;
			if ($count + $count2 >4 ){next;}
			chomp($_);
			@e=split(/\t/, $_);
			$flag = 1;$p1=0;
			for $y (9..$#e) {	
				if ($e[$y] =~/^(\d)\|(\d)/){$p1 = $1 + $2;}
				else {print "problem with the entry $y \n";}
				if ($p1 >0 ) {
					if ($flag) {	
						$flag =0;
						print OUT "CHR$e[0]\t$e[1]\t$e[2]\t$e[3]\t$e[4]\t$column_pop{$y}_$column_id{$y}\t"; 
					}
					else {
						print OUT "$column_pop{$y}_$column_id{$y}\t"; 
					}
				}
			}
			print OUT "\n"; 
		}
	}
}
